# Чтение входных данных
n, q, k = map(int, input().split())
favorite_permutation = list(map(int, input().split()))

# Функция для изменения порядка выполнения дел
def change_order(order, l, r):
    # Назначение приоритетов
    priorities = favorite_permutation[l - 1:r]
    
    # Упорядочивание дел в порядке возрастания приоритетов
    sorted_order = sorted(order, key=lambda x: priorities[x - l])
    
    return sorted_order

order = list(range(1, n + 1))  # Исходный порядок выполнения дел

# Изменение порядка выполнения дел q раз
for i in range(q):
    l, r = map(int, input().split())
    order = change_order(order, l, r)

# Определение, какое дело Юрик выполнит k-м по счету
kth_task = order[k - 1]

# Вывод результата
print(kth_task)
